#define _GNU_SOURCE
#include <dlfcn.h>
#define _XOPEN_SOURCE 500
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
/*#include <stddev.h>
  #include <glob.h>*/
#include <sys/timeb.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
//#define TRACE
const char* config_name;
ssize_t write_call_limit;
ssize_t write_call_count;

void read_config()
{
  FILE* f= fopen(config_name,"r");
  if(NULL == f)
  {
    return;
  }
  char buffer[1024];
  fgets(buffer,sizeof(buffer),f);
  fclose(f);
  write_call_limit= atoi(buffer);
};

typedef ssize_t (*write_signature)(int, const void*, size_t);
write_signature real_write;
void write_config()
{
  FILE* f= fopen(config_name,"w");
  char buffer[1024];
  int length= 0;
  if(-1 == f)
  {
    return;
  }
  length=snprintf(buffer,sizeof(buffer),"%d\n",(int)write_call_limit);
  fputs(buffer,f);
  fclose(f);
}
ssize_t write(int fd, const void* buf, size_t count)
{
  if(0 == write_call_limit)
  {
    read_config();
  }
  if(0 != write_call_limit)
  {
    write_call_count = write_call_count + 1;
    if(write_call_count >= write_call_limit)
    {
      write_call_count= 0;
      write_call_limit= 0;
      write_config();
#ifdef TRACE
      fprintf( stderr, "error provocated\n" );
#endif // TRACE
      errno = ENOSPC;
      return -1;
    }
  }
  return (*real_write)(fd,buf,count);
}
void load_real_call(void** function, const char* name)
{
#ifdef TRACE
  fprintf( stderr, "%s: make wrapping start...\n", name );
#endif // TRACE
  (*function) = dlsym( RTLD_NEXT, name );
#ifdef TRACE
  fprintf( stderr, "real_%s = %p\n", name, (*function) );
#endif // TRACE
  fflush( stderr );
  {
    const char* message = dlerror();
    if( NULL != message  )
    {
      fprintf( stderr,"%s: dlopen failed: %s\n", name, message );
      fflush(stderr);
      exit(1);
    }
    else
    {
#ifdef TRACE
      fprintf( stderr,"%s: make wrapping complete\n", name, message );
#endif // TRACE
    }
  }
}
void _init()
{
  config_name= "/storage/project/percona/error.cfg";
  write_call_limit= 0;
  write_call_count= 0;
  real_write= NULL;
  load_real_call((void**)&real_write,"write");
}

void _fini()
{
}

